package robust.pm.code;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.Vector;

import robust.pm.dbmanager.DBCPConn;

import robust.pm.code.CodeEntity;
import robust.pm.code.CodeManager;

import robust.pm.logger.CSLogger;


/**
 *======================================================
 * @Ŭ : CodeDAO
 * @ۼ  : Administrator
 * @    : ڵ
 *======================================================
 * @̷ - , , 
 *
 *======================================================
 */ 
public class CodeDAO {
	/**
     * SELECT, LIST ϴ ResultSet Get
     * @param        rs ResultSet
     * @exception    SQLException    Ÿ̽ ó 
     * @return     Bind ó  + 1
     */
    private CodeEntity resultSetGet(ResultSet rs) throws SQLException {
    	CodeEntity resultEntity = new CodeEntity();
        int colSeq = 1;
        
        resultEntity.m_sGenGrpCd = rs.getString(colSeq++); 
        resultEntity.m_sGrpShortName = rs.getString(colSeq++); 
        resultEntity.m_sGrpLongName = rs.getString(colSeq++); 
        resultEntity.m_sCdShortName = rs.getString(colSeq++); 
        resultEntity.m_sCdLongName = rs.getString(colSeq++);        
        resultEntity.m_sValCd = rs.getString(colSeq++);        
        resultEntity.m_iDispSeq = rs.getInt(colSeq++); 
        
        return resultEntity;
    }
    
	/**
	 *======================================================
	 * @޼ҵ : CodeDAO - selectCode
	 * @ۼ  : Administrator
	 * @return  : TCmmGenCdEntity[]
	 * @param grpNm
	 * @    :  ڵ ׷  ȸѴ.
	 *======================================================
	 * @̷ : , , 
	 *
	 *======================================================
	 */
	public CodeEntity[] selectCode(CodeEntity pEntity) throws SQLException{
		Connection conn = null;
		PreparedStatement pstmt = null;
		ResultSet rset = null;
		
		int index = 1;
		
		Vector vec = new Vector();
		CodeEntity[] entities = null;
		CodeEntity entity = null;
		
		String sSql = " SELECT									\n"
					+ "		A.GEN_GRP_CD,						\n"
					+ "		A.SHORT_NM AS GRP_SHORT_NAME,		\n"	
					+ "		A.LONG_NM AS GRP_LONG_NAME,			\n"	
					+ "		B.SHORT_NM AS CD_SHORT_NAME,		\n"
					+ "		B.LONG_NM AS CD_LONG_NAME,			\n"
					+ "		B.GEN_CD,B.DISP_SEQ					\n"
					+ "	FROM TGEN_GRP_CD A JOIN TGEN_CD B	\n"
					+ "		ON 	A.GEN_GRP_CD = B.GEN_GRP_CD		\n"
					+ "		AND A.DEL_YN = B.DEL_YN				\n"
					+ " 	AND A.GEN_GRP_CD = ?                \n"
					+ "		AND A.DEL_YN = ?					\n"
					+ "	ORDER BY GEN_GRP_CD,DISP_SEQ			\n";	
	
		try{
			conn = DBCPConn.getConnection("pool");
			
			pstmt = conn.prepareStatement(sSql);
			pstmt.setString(index++, pEntity.m_sGenGrpCd);
			pstmt.setString(index++, pEntity.m_sDelYn);
			
			rset = pstmt.executeQuery();
			
			while(rset.next()){
				entity = resultSetGet(rset);
				vec.addElement(entity);
			}
		}catch (SQLException sqle) {
			CSLogger.error(sqle.toString());
			throw sqle;
		}catch (Exception sqle) {
			CSLogger.error(sqle.toString());
		} finally {
			try{
				rset.close();
				pstmt.close();
				conn.close();
			}catch(SQLException sx) {}
		}

		if (vec.size() > 0) {
			entities = new CodeEntity[vec.size()];
			vec.copyInto(entities);
			vec.clear();
			vec = null;
		}

		return entities;
	}
	
	/**
	 *======================================================
	 * @޼ҵ : CodeDAO - listTotal
	 * @ۼ  : Administrator
	 * @return  : int
	 * @param pEntity
	 * @    : ڵ Ʈ ѰǼ 
	 *======================================================
	 * @̷ : , , 
	 *
	 *======================================================
	 */
	public int listTotal(CodeEntity pEntity) throws SQLException{
		Connection conn = null;
		PreparedStatement pstmt = null;
		ResultSet rset = null;
		
		int index = 1;
		int rtnCnt = 0;
		
		String sSql = " SELECT									\n"							 
					+ "		COUNT(*) CNT						\n"
					+ "	FROM TGEN_GRP_CD A JOIN TGEN_CD B	\n"		
					+ "		ON A.GEN_GRP_CD = B.GEN_GRP_CD		\n"	
					+ "		AND A.DEL_YN = B.DEL_YN				\n"
					+ "		AND A.GEN_GRP_CD = ?				\n"               
					+ "		AND A.DEL_YN = ?					\n"				
					+ "	ORDER BY DISP_SEQ						\n";		
	
		try{
			conn = DBCPConn.getConnection("pool");
			
			pstmt = conn.prepareStatement(sSql);
			pstmt.setString(index++, pEntity.m_sGenGrpCd);
			pstmt.setString(index++, pEntity.m_sDelYn);
			
			rset = pstmt.executeQuery();
			
			if(rset.next()){
				rtnCnt = rset.getInt("CNT");
			}
			
		}catch (SQLException sqle) {
			CSLogger.error(sqle.toString());
			throw sqle;
		}catch (Exception sqle) {
			CSLogger.error(sqle.toString());
		} finally {
			try{
				rset.close();
				pstmt.close();
				conn.close();
			}catch(SQLException sx) {}
		}
		
		return rtnCnt;
	}
	
	
	/**
	 *======================================================
	 * @޼ҵ : CodeDAO - list
	 * @ۼ  : Administrator
	 * @return  : int
	 * @param pEntity
	 * @    : ڵ ȸ Ʈ
	 *======================================================
	 * @̷ : , , 
	 *
	 *======================================================
	 */
	public CodeEntity[] list(int iPage,int iPagePerCnt,CodeEntity pEntity) throws SQLException{
		Connection conn = null;
		PreparedStatement pstmt = null;
		ResultSet rset = null;
		
		int index = 1;
		
		Vector vec = new Vector();
		CodeEntity[] entities = null;
		CodeEntity entity = null;
		
		String sSql = " SELECT"
					+ "		GEN_GRP_CD,						\n"
					+ "		GRP_SHORT_NAME,					\n"		
					+ "		GRP_LONG_NAME,					\n"	
					+ "		CD_SHORT_NAME,					\n"
					+ "		CD_LONG_NAME,					\n"
					+ "		VAL_CD,DISP_SEQ					\n"
					+ " FROM								\n"
					+ "     (SELECT @ROWNUM:=0) R,          \n"
					+ "		(SELECT							\n"
					+ "			@ROWNUM:=@ROWNUM+1 AS RNUM, \n"
					+ "			TAB.*						\n"
					+ "		FROM( 							\n"
					+ " 		SELECT									\n"							 
					+ "				A.GEN_GRP_CD,						\n"
					+ "				A.SHORT_NM AS GRP_SHORT_NAME,		\n"		
					+ "				A.LONG_NM AS GRP_LONG_NAME,			\n"	
					+ "				B.SHORT_NM AS CD_SHORT_NAME,		\n"
					+ "				B.LONG_NM AS CD_LONG_NAME,			\n"
					+ "				B.GEN_CD AS VAL_CD,B.DISP_SEQ		\n"
					+ "			FROM TGEN_GRP_CD A JOIN TGEN_CD B	\n"		
					+ "				ON A.GEN_GRP_CD = B.GEN_GRP_CD		\n"	
					+ "				AND A.DEL_YN = B.DEL_YN				\n"
					+ "				AND A.GEN_GRP_CD = ?				\n"               
					+ "				AND A.DEL_YN = ?					\n"				
					+ "			ORDER BY DISP_SEQ						\n"
					+ "		) TAB										\n"
					+ " ) X WHERE X.RNUM BETWEEN ? AND ?				\n";
		
		
		try{
			conn = DBCPConn.getConnection("pool");
			
			pstmt = conn.prepareStatement(sSql);
			pstmt.setString(index++, pEntity.m_sGenGrpCd);
			pstmt.setString(index++, pEntity.m_sDelYn);
			pstmt.setInt(index++, (iPage * iPagePerCnt)- (iPagePerCnt-1));
	        pstmt.setInt(index++, iPage * iPagePerCnt);
	        
	        rset = pstmt.executeQuery();
			
			while(rset.next()){
				entity = resultSetGet(rset);
				vec.addElement(entity);
			}
			
		}catch (SQLException sqle) {
			CSLogger.error(sqle.toString());
			throw sqle;
		}catch (Exception sqle) {
			CSLogger.error(sqle.toString());
		} finally {
			try{
				rset.close();
				pstmt.close();
				conn.close();
			}catch(SQLException sx) {}
		}
		
		if (vec.size() > 0) {
			entities = new CodeEntity[vec.size()];
			vec.copyInto(entities);
			vec.clear();
			vec = null;
		}

		return entities;
	}
	
	/**
	 *======================================================
	 * @޼ҵ : CodeDAO - getGrpCode
	 * @ۼ  : Administrator
	 * @return  : CodeEntity[]
	 * @param pEntity
	 * @    : ׷ ڵ尪 ȸѴ.
	 *======================================================
	 * @̷ : , , 
	 *
	 *======================================================
	 */
	public CodeEntity[] getGrpCode(CodeEntity pEntity) throws SQLException{
		Connection conn = null;
		PreparedStatement pstmt = null;
		ResultSet rset = null;
		
		int index = 1;
		
		Vector vec = new Vector();
		CodeEntity[] entities = null;
		CodeEntity entity = null;
		
		String sSql = "  SELECT									\n" 
					+ "		GEN_GRP_CD,SHORT_NM AS SHORT_NAME	\n"
					+ "	 FROM TGEN_GRP_CD						\n"
					+ "	 WHERE DEL_YN = ?						\n"
					+ "	 ORDER BY SHORT_NM						\n";

		try{
			conn = DBCPConn.getConnection("pool");
			
			pstmt = conn.prepareStatement(sSql);
			pstmt.setString(index++,pEntity.m_sDelYn);
			
			rset = pstmt.executeQuery();
			
			while(rset.next()){
				entity = new CodeEntity();
				
				entity.m_sGenGrpCd = rset.getString("GEN_GRP_CD");
				entity.m_sGrpShortName = rset.getString("SHORT_NAME");
				
				vec.addElement(entity);
			}
			
		}catch (SQLException sqle) {
			CSLogger.error(sqle.toString());
			throw sqle;
		}catch (Exception sqle) {
			CSLogger.error(sqle.toString());
		} finally {
			try{
				rset.close();
				pstmt.close();
				conn.close();
			}catch(SQLException sx) {}
		}

		if (vec.size() > 0) {
			entities = new CodeEntity[vec.size()];
			vec.copyInto(entities);
			vec.clear();
			vec = null;
		}

		return entities;
	}
	
	/**
	 *======================================================
	 * @޼ҵ : CodeDAO - insert
	 * @ۼ  : Administrator
	 * @return  : int
	 * @param pEntity
	 * @    : ڵ  Ѵ.
	 *======================================================
	 * @̷ : , , 
	 *
	 *======================================================
	 */
	public int insert(CodeEntity pEntity)throws SQLException{
		Connection conn = null;
		PreparedStatement pstmt = null;
		
		int index = 1;
		int rtnCk = 0;
		
		String sSql = "	 INSERT INTO TGEN_CD					\n"
					+ "	 (GEN_GRP_CD, GEN_CD,					\n"
					+ "	  SHORT_NM,LONG_NM,DISP_SEQ,			\n"
					+ "	  REG_DTM,REG_USER_ID,									\n"
					+ "	  LAST_UPD_DTM,LAST_UPD_USER_ID,						\n"
					+ "	  DEL_YN)												\n"
					+ "	 VALUES(?,?,											\n"
					+ "	 		?,?,?,											\n"
					+	"		DATE_FORMAT(SYSDATE(),'%Y-%m-%d %H:%i:%s'),?,	\n"
					+	"		DATE_FORMAT(SYSDATE(),'%Y-%m-%d %H:%i:%s'),?,	\n"
					+ "	 		?							 					\n"
					+ "	 ) 														\n";
		
		try{
			conn = DBCPConn.getConnection("pool");
			
			pstmt = conn.prepareStatement(sSql);
			pstmt.setString(index++, pEntity.m_sGenGrpCd);
			pstmt.setString(index++, pEntity.m_sValCd);
			pstmt.setString(index++, pEntity.m_sCdShortName);
			pstmt.setString(index++, pEntity.m_sCdLongName);
			pstmt.setInt(index++, pEntity.m_iDispSeq);
			pstmt.setString(index++, pEntity.m_sRegId);
			pstmt.setString(index++, pEntity.m_sLastUpdId);
			pstmt.setString(index++, pEntity.m_sDelYn);
			
			rtnCk = pstmt.executeUpdate();
			
		}catch (SQLException sqle) {
			CSLogger.error(sqle.toString());
			throw sqle;
		}catch (Exception sqle) {
			CSLogger.error(sqle.toString());
		} finally {
			try{
				pstmt.close();
				conn.close();
			}catch(SQLException sx) {}
		}
		
		return rtnCk;
	}
	
	/**
	 *======================================================
	 * @޼ҵ : CodeDAO - insert
	 * @ۼ  : Administrator
	 * @return  : int
	 * @param pEntity
	 * @    : ڵ  Ѵ.
	 *======================================================
	 * @̷ : , , 
	 *
	 *======================================================
	 */
	public int modify(CodeEntity pEntity)throws SQLException{
		Connection conn = null;
		PreparedStatement pstmt = null;
		
		int index = 1;
		int rtnCk = 0;
		
		String sSql = "	UPDATE TGEN_CD					\n"
					+ "	SET SHORT_NM = ?  ,				\n"
					+ "		LONG_NM = ? ,				\n"
					+ "		DISP_SEQ = ? ,				\n"
					+ "		LAST_UPD_DTM =  DATE_FORMAT(SYSDATE(),'%Y-%m-%d %H:%i:%s'),	\n"
					+ "		LAST_UPD_USER_ID = ?		\n"
					+ "	WHERE GEN_GRP_CD = ?			\n"
					+ "	AND DEL_YN = ?					\n";
		
		try{
			conn = DBCPConn.getConnection("pool");
			
			pstmt = conn.prepareStatement(sSql);
			pstmt.setString(index++, pEntity.m_sCdShortName);
			pstmt.setString(index++, pEntity.m_sCdLongName);
			pstmt.setInt(index++, pEntity.m_iDispSeq);
			pstmt.setString(index++, pEntity.m_sLastUpdId);
			pstmt.setString(index++, pEntity.m_sGenGrpCd);			
			pstmt.setString(index++, pEntity.m_sDelYn);
			
			rtnCk = pstmt.executeUpdate();
			
		}catch (SQLException sqle) {
			CSLogger.error(sqle.toString());
			throw sqle;
		}catch (Exception sqle) {
			CSLogger.error(sqle.toString());
		} finally {
			try{
				pstmt.close();
				conn.close();
			}catch(SQLException sx) {}
		}
		
		return rtnCk;
	}
	
	/**
	 *======================================================
	 * @޼ҵ : CodeDAO - select
	 * @ۼ  : Administrator
	 * @return  : CodeEntity
	 * @param pEntity
	 * @    : ڵ ȸѴ.
	 *======================================================
	 * @̷ : , , 
	 *
	 *======================================================
	 */
	public CodeEntity select(CodeEntity pEntity)throws SQLException{
		Connection conn = null;
		PreparedStatement pstmt = null;
		ResultSet rset = null;
		
		int index = 1;
		
		CodeEntity entity = null;
		
		String sSql = " SELECT						\n" 
					+ "		A.GEN_GRP_CD,			\n"
					+ "		A.SHORT_NM AS GRP_SHORT_NAME,		\n"	
					+ "		A.LONG_NM AS GRP_LONG_NAME,			\n"	
					+ "		B.SHORT_NM AS CD_SHORT_NAME,		\n"
					+ "		B.LONG_NM AS CD_LONG_NAME,			\n"
					+ "		B.GEN_CD AS VAL_CD,B.DISP_SEQ		\n"
					+ "	FROM TGEN_GRP_CD A JOIN TGEN_CD B	\n"
					+ "		ON A.GEN_GRP_CD = B.GEN_GRP_CD		\n"
					+ "		AND A.DEL_YN = B.DEL_YN				\n"
					+ " 	AND A.GEN_GRP_CD = ?                \n"
					+ "		AND A.DEL_YN = ?					\n";
		
		try{
			conn = DBCPConn.getConnection("pool");
			
			pstmt = conn.prepareStatement(sSql);
			pstmt.setString(index++, pEntity.m_sGenGrpCd);
			pstmt.setString(index++, pEntity.m_sDelYn);
			
			rset = pstmt.executeQuery();
			
			while(rset.next()){
				entity = resultSetGet(rset);
			}
		}catch (SQLException sqle) {
			CSLogger.error(sqle.toString());
			throw sqle;
		}catch (Exception sqle) {
			CSLogger.error(sqle.toString());
		} finally {
			try{
				rset.close();
				pstmt.close();
				conn.close();
			}catch(SQLException sx) {}
		}
		
		return entity;
	}
}
