package robust.pm.notice.service;

import java.sql.Connection;
import java.sql.SQLException;
import java.util.List;

import robust.pm.notice.dao.*;
import robust.pm.notice.model.*;
import robust.pm.dbmanager.*;

public class qListArticleService {
	private static qListArticleService instance = new qListArticleService();
	public static qListArticleService getInstance() {
		return instance;
	}
	
	public static final int COUNT_PER_PAGE = 10;

	public qArticleListModel getArticleList(int requestPageNumber) {
		if (requestPageNumber < 0) {
			throw new IllegalArgumentException("page number < 0 : "
					+ requestPageNumber);
		}
		qArticleDao articleDao = qArticleDao.getInstance();
		Connection conn = null;
		try {
			conn = DBCPConn.getConnection("pool");
			int totalArticleCount = articleDao.selectCount(conn);

			if (totalArticleCount == 0) {
				return new qArticleListModel();
			}

			int totalPageCount = calculateTotalPageCount(totalArticleCount);

			int firstRow = (requestPageNumber - 1) * COUNT_PER_PAGE + 1;
			int endRow = firstRow + COUNT_PER_PAGE - 1;

			if (endRow > totalArticleCount) {
				endRow = totalArticleCount;
			}
			List<qArticle> articleList = articleDao.select(conn, firstRow,
					endRow);

			qArticleListModel articleListView = new qArticleListModel(
					articleList, requestPageNumber, totalPageCount, firstRow,
					endRow);
			return articleListView;
		} catch (SQLException e) {
			throw new RuntimeException("DB  ߻:"+e.getMessage(), e);
		} finally {
			JdbcUtil.close(conn);
		}
	}

	private int calculateTotalPageCount(int totalArticleCount) {
		if (totalArticleCount == 0) {
			return 0;
		}
		int pageCount = totalArticleCount / COUNT_PER_PAGE;
		if (totalArticleCount % COUNT_PER_PAGE > 0) {
			pageCount++;
		}
		return pageCount;
	}
}
