package robust.pm.project;

import java.sql.SQLException;
import java.util.ArrayList;

import robust.pm.project.ProjectInfoDAO;
import robust.pm.project.ProjectInfoEntity;
import robust.pm.user.UserDAO;
import robust.pm.user.UserEntity;

public class ProjectManager{
	 private static ProjectInfoDAO            m_ProjectDAO;
	 private static ProjectMemDAO            m_ProjectMemberDAO;
	 private static ProjectTaskDAO            m_ProjectTaskDAO;
		
	 public ProjectManager(){
		
	
	}
    /**
     *======================================================
     * @޼ҵ : ProjectManager - get
     * @return  : ProjectEntity
     * @param pEntity  ڰ Entity
     * @    : Ʈ  ȸѴ.
     *======================================================
     * @̷ : , , 
     *
     *======================================================
     */
    public static ProjectInfoEntity get( ProjectInfoEntity pEntity
    				)throws SQLException {
      
        if ( m_ProjectDAO == null) {
        	m_ProjectDAO = new ProjectInfoDAO( );
        }
        
        return m_ProjectDAO.getDB(pEntity.getPrj_id()) ;
    }

    /**
     *======================================================
     * @޼ҵ : ProjectManager - updateDB
     * @return  : Ʈ 
     * @param pEntity Ʈ  Entity
     * @    : Ʈ  Ѵ.
     *======================================================
     */
    public boolean updateDB(ProjectInfoEntity pEntity) throws SQLException{
    	if ( m_ProjectDAO == null) {
        	m_ProjectDAO = new ProjectInfoDAO( );
        }
        
        return m_ProjectDAO.updateDB(pEntity);
    }
   
    
    

    /**
     *======================================================
     * @޼ҵ : ProjectManager - list
     * @return  : ProjectEntity[]
     * @param pEntity   Ʈ Entity
     * @param iPage		 
     * @param iPagePerCnt Ʈ
     * @    : Ʈ  ȸѴ.
     *======================================================
     */
    public static ArrayList<ProjectInfoEntity> list( ProjectInfoEntity pEntity
    												,int iPage,int iPagePerCnt)throws SQLException {
      
        if ( m_ProjectDAO == null) {
        	m_ProjectDAO = new ProjectInfoDAO( );
        }
        
        return m_ProjectDAO.getDBList();
    }
    
  ////////////////////////////////////////////////////////////////////////////////////////////  
    /**
     *======================================================
     * @޼ҵ : ProjectManager - get_member
     * @return  : ProjectMemberEntity
     * @param pEntity  ڰ Entity
     * @    : Ʈ  MEMBER  ȸѴ.
     *======================================================
     * @̷ : , , 
     *
     *======================================================
     */
    public static ProjectMemEntity get( ProjectMemEntity pEntity
    				)throws SQLException {
      
        if ( m_ProjectMemberDAO == null) {
        	m_ProjectMemberDAO = new ProjectMemDAO( );
        }
        
        return m_ProjectMemberDAO.get_UserDB(pEntity.getUser_id()) ;
    }

    /**
     *======================================================
     * @޼ҵ : ProjectManager - list_Member
     * @return  : ProjectEntity[]
     * @param pEntity   Ʈ Entity
     * @param iPage		 
     * @param iPagePerCnt Ʈ
     * @    : Ʈ Member ȸѴ.
     *======================================================
     */
    public static ArrayList<ProjectMemEntity> list( ProjectMemEntity pEntity
    												,int iPage,int iPagePerCnt)throws SQLException {
      
        if ( m_ProjectMemberDAO == null) {
        	m_ProjectMemberDAO = new ProjectMemDAO( );
        }
        
        return m_ProjectMemberDAO.get_UserDBList();
    }
    
    
    
    
    
}
