package robust.pm.servlet;


import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;

import javax.servlet.ServletOutputStream;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * Servlet Downloadÿ   Utility
 * @author Jongpil Won
 * @version 1.0 03/01/15 
 **/
public class DownloadUtil {
    /**
     * ̾ޱⰡ ϵ ٿεѴ. <p>
     * Ʒ ڵ带 Ѵ.
     * <xmp>
     *	File	file = new File(filename);
     *	download(request, response, file, file.getName());
     * </xmp>
     * @param request
     * @param response
     * @param filename ٿε ϸ ( ϸ)
     **/
    public static void download(HttpServletRequest request, HttpServletResponse response, String filename) throws IOException {
	File	file = new File(filename);
	download(request, response, file, file.getName());
    }
    /**
     * ̾ޱⰡ ϵ ٿεѴ. <p>
     * Ʒ ڵ带 Ѵ.
     * <xmp>
     *	download(request, response, new File(filename), downloadname);
     * </xmp>
     * @param request
     * @param response
     * @param filename ٿε ϸ ( ϸ)
     * @param downloadname ٿεÿ  ϸ (content-disposition )
     **/
    public static void download(HttpServletRequest request, HttpServletResponse response, String filename, String downloadname) throws IOException {
	download(request, response, new File(filename), downloadname);
    }
    /**
     * ̾ޱⰡ ϵ ٿεѴ. <p>
     * Ʒ ڵ带 Ѵ.
     * <xmp>
     *	download(request, response, file, file.getName());
     * </xmp> 
     * @param request
     * @param response
     * @param file ٿε 
     **/
    public static void download(HttpServletRequest request, HttpServletResponse response, File file) throws IOException {
	download(request, response, file, file.getName());
    }
    /**
     * ̾ޱⰡ ϵ ٿεѴ.
     * @param request
     * @param response
     * @param file ٿε 
     * @param downloadname ٿεÿ  ϸ (content-disposition )
     **/
    public static void download(HttpServletRequest request, HttpServletResponse response, File file, String downloadname) throws IOException {

	String range = request.getHeader("RANGE");	// or "RANGE"
	long	startPos=0;
	long	endPos=file.length();
	long	totalLength=0;
	int	lastrange=0;
	boolean	partial = false;

	if (range != null && range.startsWith("bytes=")) {
		range = range.substring(6);
		if (range.indexOf(',') >= 0) {
			// I don't know how to do multiple range
			partial = false;
		} else {
			lastrange = range.indexOf('-');
			if (lastrange < 0) {
				partial = false;
			} else if (lastrange == 0) {
				try {
					startPos = file.length() - Long.parseLong(range.substring(lastrange+1));
					endPos = file.length();
					partial = true;
				} catch (NumberFormatException nfe) {
					nfe.printStackTrace(System.err);
					startPos = 0; endPos = file.length();
					partial = false;
				} catch (ArrayIndexOutOfBoundsException aiooe) {
					aiooe.printStackTrace(System.err);
					startPos = 0; endPos = file.length();
					partial = false;
				}
			} else if (lastrange == range.length()-1) {
				try {
					startPos = Long.parseLong(range.substring(0, lastrange));
					endPos = file.length();
					partial = true;
				} catch (NumberFormatException nfe) {
					nfe.printStackTrace(System.err);
					startPos = 0; endPos = file.length();
					partial = false;
				} catch (ArrayIndexOutOfBoundsException aiooe) {
					aiooe.printStackTrace(System.err);
					startPos = 0; endPos = file.length();
					partial = false;
				}
			} else {
				try {
					startPos = Long.parseLong(range.substring(0, lastrange));
					endPos = Long.parseLong(range.substring(lastrange+1))+1;
					if (endPos < startPos) endPos = file.length();
					partial = true;
				} catch (NumberFormatException nfe) {
					nfe.printStackTrace(System.err);
					startPos = 0; endPos = file.length();
					partial = false;
				} catch (ArrayIndexOutOfBoundsException aiooe) {
					aiooe.printStackTrace(System.err);
					startPos = 0; endPos = file.length();
					partial = false;
				}

			}
		}
	}
	totalLength = endPos - startPos;

	response.reset();
	response.setContentType("application/x-msdownload");
	response.setContentLength((int) totalLength);
	response.addHeader("Accept-Range", "bytes");
	response.addHeader("Content-Dispostion", "attachment; filename=\""+downloadname+"\"");
	response.addDateHeader("Last-Modified", file.lastModified());
	if (partial) {
		response.addHeader("Content-Range", "bytes "+startPos+"-"+endPos+"/"+file.length());
	}
	ServletOutputStream outStream = response.getOutputStream();
	FileInputStream fis = new FileInputStream(file);
	byte[]	buffer = new byte[8192];
	int	readed = 0;
	fis.skip(startPos);
	while (totalLength > 0) {
		readed = fis.read(buffer, 0, 8192);
		if (readed > totalLength) readed = (int) totalLength;
		outStream.write(buffer, 0, readed);
		totalLength -= (long) readed;
	}
	fis.close();
	outStream.flush();
	outStream.close();
    }
}


