package robust.pm.user;

import java.sql.SQLException;

import robust.pm.user.UserDAO;
import robust.pm.user.UserEntity;


/**
 *======================================================
 * @Ŭ : UserManager
 * @    :   Manager
 *======================================================
 * @̷ - , , 
 *
 *======================================================
 */ 
public class UserManager {

	/**
     * m_UserDAO ü س Ѵ.
     */
    private static UserDAO            m_UserDAO;
    
    /*******************************************************************************************
     *  Լ, ʱȭ ۾
     * ܺο staticθ 밡ϵ .
     *******************************************************************************************/    
    private UserManager() {
    }

    /**
     *======================================================
     * @޼ҵ : UserManager - get
     * @return  : UserEntity
     * @param pEntity  ڰ Entity
     * @    :  ȸѴ.
     *======================================================
     * @̷ : , , 
     *
     *======================================================
     */
    public static UserEntity get( UserEntity pEntity
    				)throws SQLException {
      
        if ( m_UserDAO == null) {
        	m_UserDAO = new UserDAO( );
        }
        
        return m_UserDAO.select(pEntity) ;
    }

    /**
     *======================================================
     * @޼ҵ : UserManager - list
     * @return  : UserEntity[]
     * @param pEntity     Entity
     * @param iPage		 
     * @param iPagePerCnt Ʈ
     * @    :   ȸѴ.
     *======================================================
     */
    public static UserEntity[] list( UserEntity pEntity
    												,int iPage,int iPagePerCnt)throws SQLException {
      
        if ( m_UserDAO == null) {
        	m_UserDAO = new UserDAO( );
        }
        
        return m_UserDAO.list(pEntity,iPage,iPagePerCnt) ;
    }

    /**
     *======================================================
     * @޼ҵ : UserManager - listCount
     * @return  : int Ѱ߼
     * @param pEntity ڰ Entity
     * @    :   ü Ǽ
     *======================================================
     */
    public static int listCount( UserEntity pEntity
    															) throws SQLException{
      
        if ( m_UserDAO == null) {
        	m_UserDAO = new UserDAO( );
        }
        
        return m_UserDAO.listCount(pEntity) ;
    } 
    
    /**
     *======================================================
     * @޼ҵ : UserManager - insert
     * @return  : int  Ȯΰ
     * @param pEntity ڰ Entity
     * @    :   Ѵ.
     *======================================================
     */
    public static int insert(UserEntity pEntity) throws SQLException{
    	if ( m_UserDAO == null) {
        	m_UserDAO = new UserDAO( );
        }
        
        return m_UserDAO.insert(pEntity) ;
    }
    
    /**
     *======================================================
     * @޼ҵ : UserManager - modify
     * @return  : int  Ȯΰ
     * @param pEntity ڰ Entity
     * @    :   Ѵ.
     *======================================================
     */
    public static int modify(UserEntity pEntity) throws SQLException{
    	if ( m_UserDAO == null) {
        	m_UserDAO = new UserDAO( );
        }
        
        return m_UserDAO.modify(pEntity) ;
    }
    
    /**
     *======================================================
     * @޼ҵ : UserManager - insert
     * @return  : int  Ȯΰ
     * @param chkUserId   ̵
     * @    :   Ѵ.
     *======================================================
     * @̷ : , , 
     *
     *======================================================
     */
    public static int delete(UserEntity pEntity,String[] chkUserId) throws SQLException{
    	if ( m_UserDAO == null) {
        	m_UserDAO = new UserDAO( );
        }
        
        return m_UserDAO.delete(pEntity,chkUserId) ;
    }

    /**
     *======================================================
     * @޼ҵ : UserManager - getUserGrp
     * @return  : UserEntity[]
     * @return
     * @    : ڱ׷  Ʈ 
     *======================================================
     * @̷ : , , 
     *
     *======================================================
     */
    public static UserEntity[] getUserGrp() throws SQLException{
    	if ( m_UserDAO == null) {
        	m_UserDAO = new UserDAO( );
        }
        
        return m_UserDAO.getUserGrp() ;
    }
    
    /**
     *======================================================
     * @޼ҵ : UserManager - getDept
     * @return  : UserEntity[]
     * @return
     * @    : μ  Ʈ 
     *======================================================
     * @̷ : , , 
     *
     *======================================================
     */
    public static UserEntity[] getDept() throws SQLException{
    	if ( m_UserDAO == null) {
        	m_UserDAO = new UserDAO( );
        }
        
        return m_UserDAO.getDept() ;
    }
    
    /**
     *======================================================
     * @޼ҵ : UserManager - getPost
     * @return  : UserEntity[]
     * @return
     * @    :  Ʈ
     *======================================================
     * @̷ : , , 
     *
     *======================================================
     */
    public static UserEntity[] getPost() throws SQLException{
    	if ( m_UserDAO == null) {
        	m_UserDAO = new UserDAO( );
        }
        
        return m_UserDAO.getPost() ;
    }

    /**
     *======================================================
     * @޼ҵ : UserManager - getLastSch
     * @return  : UserEntity[]
     * @return
     * @    : з  Ʈ
     *======================================================
     * @̷ : , , 
     *
     *======================================================
     */
    public static UserEntity[] getLastSch() throws SQLException{
    	if ( m_UserDAO == null) {
        	m_UserDAO = new UserDAO( );
        }
        
        return m_UserDAO.getLastSch() ;
    }

    /**
     *======================================================
     * @޼ҵ : UserManager - getForeignCap
     * @return  : UserEntity[]
     * @return
     * @    : ܱɷ  Ʈ
     *======================================================
     * @̷ : , , 
     *
     *======================================================
     */
    public static UserEntity[] getForeignCap() throws SQLException{
    	if ( m_UserDAO == null) {
        	m_UserDAO = new UserDAO( );
        }
        
        return m_UserDAO.getForeignCap() ;
    }
    
    /**
     *======================================================
     * @޼ҵ : UserManager - getUserIdChk
     * @return  : int
     * @return
     * @    :  ̵ ߺ üũ 
     *======================================================
     * @̷ : , , 
     *
     *======================================================
     */
    public static int getUserIdChk(String userId) throws SQLException{
    	if ( m_UserDAO == null) {
        	m_UserDAO = new UserDAO( );
        }
        
        return m_UserDAO.getUserIdChk(userId) ;
    }
    
    /**
     *======================================================
     * @޼ҵ : UserManager - passwdChange
     * @return  : int
     * @param pEntity
     * @return
     * @    :  йȣ 
     *======================================================
     * @̷ : , , 
     *
     *======================================================
     */
    public static int passwdChange(UserEntity pEntity) throws SQLException{
    	if ( m_UserDAO == null) {
        	m_UserDAO = new UserDAO( );
        }
        
        return m_UserDAO.passwdChange(pEntity) ;
    }
}
